## firmware-carl9170 1.9.4

=== carlfw/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(carl9170.fw)

include("../extra/sh-elf-linux.cmake")
include("../config.cmake")

set(CARLFW_CFLAGS_WARNING "-W -Wall -Wextra -Wunreachable-code -Winline -Wlogical-op -Wno-packed-bitfield-compat -Winit-self -Wshadow -Wwrite-strings -Waggregate-return -Wstrict-prototypes -Wformat=2 -Wcast-align -Wmissing-format-attribute -Wmissing-prototypes -Wtype-limits -Wmissing-declarations -Wmissing-noreturn -Wredundant-decls -Wnested-externs -Wdisabled-optimization -Wpointer-arith -Wvolatile-register-var -Waddress -Wbad-function-cast -Wunsafe-loop-optimizations")
set(CARLFW_CFLAGS_EXTRA "-mbitops -std=gnu99 -ffunction-sections -Wframe-larger-than=128 -Werror")
set(CARLFW_CFLAGS_DEF "-D__CARL9170FW__")
if (CONFIG_CARL9170FW_AGGRESSIVE_CFLAGS)
	set(CARLFW_CFLAGS_AGGRESSIVE "-fomit-frame-pointer -fsee -frename-registers -ftree-vectorize -flto -fstrict-volatile-bitfields -fmodulo-sched")
endif (CONFIG_CARL9170FW_AGGRESSIVE_CFLAGS)

include_directories (../include/linux ../include/shared ../include include)

set(carl9170_main_src src/main.c src/wlan.c src/fw.c src/gpio.c
		      src/cmd.c src/uart.c src/dma.c src/hostif.c src/reboot.S
		      src/printf.c src/rf.c src/cam.c)

set(carl9170_lib_src src/ashlsi3.S src/memcpy.S src/memset.S src/udivsi3_i4i-Os.S)
set(carl9170_usb_src usb/main.c usb/usb.c usb/fifo.c)

set(carl9170_src ${carl9170_main_src} ${carl9170_lib_src} ${carl9170_usb_src})

set_source_files_properties(src/ashlsi3.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/memcpy.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/memset.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/reboot.S PROPERTIES LANGUAGE C)
set_source_files_properties(src/udivsi3_i4i-Os.S PROPERTIES LANGUAGE C)

add_executable(carl9170.elf ${carl9170_src})

set_target_properties(carl9170.elf PROPERTIES LINKER_LANGUAGE C)

set_target_properties(carl9170.elf PROPERTIES COMPILE_FLAGS
	" ${CARLFW_CFLAGS_DEF} ${CARLFW_CFLAGS_EXTRA} ${CARLFW_CFLAGS_AGGRESSIVE} ${CARLFW_CFLAGS_WARNING}")
set_target_properties(carl9170.elf PROPERTIES LINK_FLAGS "-Tcarl9170.lds")



add_custom_target(firmware ALL)

add_custom_command(
	SOURCE carl9170.elf
	COMMAND ${OBJCOPY}
	ARGS --strip-unneeded -O binary -R .sram -R .eeprom -R .fwdsc carl9170.elf carl9170.bin
	TARGET firmware
	OUTPUTS carl9170.bin)

add_custom_command(
	SOURCE carl9170.elf
	COMMAND ${OBJCOPY}
	ARGS --strip-unneeded -O binary -j .fwdsc carl9170.elf carl9170.dsc
	TARGET firmware
	OUTPUTS carl9170.dsc)
	
add_custom_command(
	SOURCE firmware
	TARGET firmware
	COMMAND cat
	ARGS "carl9170.bin" "carl9170.dsc" > "carl9170.fw"
	DEPENDS carl9170.elf carl9170.bin carl9170.dsc
	OUTPUTS carl9170.fw)

SET_DIRECTORY_PROPERTIES(
	PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "carl9170.fw")

=== config/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(config)

#set(CMAKE_VERBOSE_MAKEFILE ON)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(MAKE_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../include/generated")

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../extra")
FIND_PACKAGE(GPERF REQUIRED) 

BISON_TARGET(zconf zconf.y zconf.tab.c COMPILE_FLAGS "-l -b zconf -p zconf")
FLEX_TARGET(zconfscan zconf.l lex.zconf.c COMPILE_FLAGS "-Pzconf -L")
GPERF_TARGET(zconfhash zconf.gperf zconf.hash.c)

SET(zconf_deps ${FLEX_zconfscan_OUTPUTS} ${GPERF_zconfhash_OUTPUTS})
SET_SOURCE_FILES_PROPERTIES(${BISON_zconf_OUTPUTS}
      PROPERTIES OBJECT_DEPENDS "${zconf_deps}")

set(conf_src conf.c ${BISON_zconf_OUTPUTS}) 

add_executable(conf ${conf_src})

=== toolchain/Makefile ===
BINUTILS_VER=2.21.1
BINUTILS_URL=http://mirrors.kernel.org/gnu/binutils/binutils-$(BINUTILS_VER).tar.bz2
BINUTILS_TAR=binutils-$(BINUTILS_VER).tar.bz2

NEWLIB_VER=1.19.0
NEWLIB_URL=ftp://sources.redhat.com/pub/newlib/newlib-$(NEWLIB_VER).tar.gz
NEWLIB_TAR=newlib-$(NEWLIB_VER).tar.gz

GCC_VER=4.6.1
GCC_URL=http://mirrors.kernel.org/gnu/gcc/gcc-$(GCC_VER)/gcc-core-$(GCC_VER).tar.bz2
GCC_TAR=gcc-core-$(GCC_VER).tar.bz2

BASEDIR=$(shell pwd)

all: gcc

src/$(BINUTILS_TAR):
	wget -P src $(BINUTILS_URL)

src/$(NEWLIB_TAR):
	wget -P src $(NEWLIB_URL)

src/$(GCC_TAR):
	wget -P src $(GCC_URL)

src/binutils-$(BINUTILS_VER): src/$(BINUTILS_TAR)
	tar -C src -xjf $<

src/newlib-$(NEWLIB_VER): src/$(NEWLIB_TAR)
	tar -C src -xzf $<

src/gcc-$(GCC_VER): src/$(GCC_TAR) src/newlib-$(NEWLIB_VER)
	tar -C src -xjf $<
	ln -s $(BASEDIR)/src/newlib-$(NEWLIB_VER)/newlib $@
	ln -s $(BASEDIR)/src/newlib-$(NEWLIB_VER)/libgloss $@

binutils: src/binutils-$(BINUTILS_VER)
	mkdir -p build/binutils
	cd build/binutils; \
	$(BASEDIR)/$</configure --target=sh-elf --prefix=$(BASEDIR)/inst; \
	$(MAKE) -j3; \
	$(MAKE) install

gcc: src/gcc-$(GCC_VER) binutils
	mkdir -p build/gcc
	cd build/gcc; \
	$(BASEDIR)/$</configure --target=sh-elf --prefix=$(BASEDIR)/inst -enable-languages=c --without-pkgversion --with-newlib; \
	$(MAKE) -j3; \
	$(MAKE) install

clean:
	rm -rf build inst

distclean: clean
	rm -rf src

=== debian/changelog ===
firmware-carl9170 (1.9.4-0~c0.aptosid.3) unstable; urgency=low

  * drop duplicate build-depends:
    - bison
    - dejagnu
    - libmpfr-dev
    - zlib1g-dev
  * override false lintian positive:
    - P: firmware-carl9170 source: unneeded-build-dep-on-quilt

 -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Wed, 23 Nov 2011 19:15:02 +0100

firmware-carl9170 (1.9.4-0~c0.aptosid.2) unstable; urgency=low

  * use reset local quiltrc.
  * close stdin, in order to create the default config non-interactively.
  * remove duplicated build-depends (lsb-release).
  * use Format instead of Format-Specification in debian/copyright and fix URL
    to use alioth's new anonscm location.
  * import latest upstream commits:
    - carl9170 firmware: report device tallies
    - carl9170 firmware: drop timer1
    - carl9170 firmware: improve site survey data
    - carl9170 firmware: fix use of uninitialized value
    - carl9170 firmware: shared register file update
    - carl9170 firmware: correct use of memset
    - carl9170 firmware: add BCN_HT1 and BCN_HT2 definitions
    - carl9170 firmware: install firmware without execute permissions
    - cfg80211: don't drop p2p probe responses
    - wireless: unify QoS control field definitions
    - ieee80211: add few wmm tspec values
    - carl9170 firmware: checkpatch/style fixes
    - carl9170 firmware: add missing out-of-bound check in WoWLAN code
    - config: import latest kconfig

 -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Wed, 23 Nov 2011 18:48:31 +0100

firmware-carl9170 (1.9.4-0~c0.aptosid.1) unstable; urgency=low

  * Initial release.

 -- Stefan Lippers-Hollmann <s.l-h@gmx.de>  Fri, 12 Aug 2011 19:57:48 +0200

=== debian/control ===
Source: firmware-carl9170
Section: kernel
Priority: optional
Maintainer: Stefan Lippers-Hollmann <s.l-h@gmx.de>
Build-Depends: debhelper (>= 8),
 autoconf (>= 2.64),
 autogen,
 cmake,
 flex,
 gettext,
 texinfo (>= 4.3),
 expect-tcl8.3 (>= 5.32.2) [hppa],
 file,
 xz-utils,
 lsb-release,
 zlib1g-dev,
 gcc-multilib [amd64 i386 mips mipsel powerpc ppc64 s390 sparc kfreebsd-amd64],
 libc6.1-dev (>= 2.5) [alpha ia64] | libc0.3-dev (>= 2.5) [hurd-i386] | libc0.1-dev (>= 2.5) [kfreebsd-i386 kfreebsd-amd64] | libc6-dev (>= 2.5),
 libc6-dev-amd64 [i386],
 libc6-dev-sparc64 [sparc],
 libc6-dev-s390x [s390],
 libc6-dev-i386 [amd64],
 libc6-dev-powerpc [ppc64],
 libc6-dev-ppc64 [powerpc],
 libc0.1-dev-i386 [kfreebsd-amd64],
 lib32gcc1 [amd64 ppc64 kfreebsd-amd64],
 lib64gcc1 [i386 powerpc sparc s390],
 libc6-dev-mips64 [mips mipsel],
 libc6-dev-mipsn32 [mips mipsel],
 m4, libtool,
 automake,
 libunwind7-dev (>= 0.98.5-6) [ia64],
 libatomic-ops-dev [ia64],
 gawk,
 lzma,
 patchutils,
 binutils (>= 2.20) | binutils-multiarch (>= 2.20),
 binutils-hppa64 (>= 2.20) [hppa],
 gperf (>= 3.0.1),
 bison (>= 1:2.3),
 libmpfr-dev (>= 2.3.0),
 locales [!m68k !knetbsd-i386 !knetbsd-alpha],
 procps,
 sharutils,
 binutils-spu (>= 2.20) [powerpc ppc64],
 newlib-spu (>= 1.16.0) [powerpc ppc64],
 libcloog-ppl-dev (>= 0.15),
 dejagnu (>= 1.4.2-1.1) [!m68k !hurd-i386 !hurd-alpha],
 realpath (>= 1.9.12),
 chrpath,
 make (>= 3.81),
 libgmp-dev,
 libmpc-dev,
 gcc-4.6-source,
 newlib-source,
 binutils-source,
 quilt
Standards-Version: 3.9.2
Homepage: http://wireless.kernel.org/en/users/Drivers/carl9170.fw
Vcs-Svn: svn://svn.berlios.de/fullstory/firmware-carl9170/trunk
Vcs-Browser: http://svn.berlios.de/wsvn/fullstory/firmware-carl9170/trunk/

Package: firmware-carl9170
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Binary firmware for Atheros AR9170
 This package contains the binary firmware for Atheros AR9170 802.11n USB WLAN
 devices, used by carl9170 community driver.
 .
 Contents:
  * Atheros AR9170 firmware for carl9170 (carl9170-1.fw)

=== debian/rules ===
#!/usr/bin/make -f

# hardcode gcc version, we need to build-depend on a specific
# gcc-$(GCC_VER)-source version anyways.
GCC_VER=4.6

# use parallel building for the toolchain, if allowed by buildd policies
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  BUILD_JOBS := $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
ifdef BUILD_JOBS
  JOBS_ARG = -j$(BUILD_JOBS)
endif

%:
	dh  $@

override_dh_auto_configure:
	# stick to the default config
	#cp --remove-destination debian/carl9170.config .config
	./autogen.sh config </dev/null
	dh_auto_configure

override_dh_auto_build:
	# toolchain build procedures loosely derived from upstream's
	# toolchain/Makefile, provided by Jan Kiszka <jan.kiszka@web.de>
	
	# unpack pre-patched binutils
	mkdir -p debian/toolchain/src/binutils
	cd debian/toolchain/src/binutils/ && \
		tar --strip 1 --xz -xf $$(dpkg -L binutils-source | grep '/usr/src/binutils/binutils-[0-9\.]*.tar.xz')
	
	# unpack and patch newlib
	mkdir -p debian/toolchain/src/newlib
	cd debian/toolchain/src/newlib/ && \
		tar --strip 1 --lzma -xf $$(dpkg -L newlib-source | grep '/usr/src/newlib/newlib-[0-9\.]*.tar.lzma'); \
		QUILT_PATCHES=/usr/src/newlib/patches quilt --quiltrc /dev/null push -a
	
	# unpack and patch gcc
	cp -r /usr/src/gcc-$(GCC_VER) debian/toolchain/src/gcc-temp
	$(MAKE) -C debian/toolchain/src/gcc-temp -f debian/rules patch
	mv debian/toolchain/src/gcc-temp/src debian/toolchain/src/gcc
	ln -fs ../newlib/newlib debian/toolchain/src/gcc/
	ln -fs ../newlib/libgloss debian/toolchain/src/gcc/
	
	# build binutils
	mkdir -p debian/toolchain/build/binutils
	cd debian/toolchain/build/binutils; \
		../../src/binutils/configure --target=sh-elf --prefix=$(CURDIR)/debian/toolchain/inst; \
		$(MAKE) $(JOBS_ARG); \
		$(MAKE) install
	
	# build gcc
	mkdir -p debian/toolchain/build/gcc
	cd debian/toolchain/build/gcc; \
		../../src/gcc/configure --target=sh-elf --prefix=$(CURDIR)/debian/toolchain/inst -enable-languages=c --without-pkgversion --with-newlib; \
		$(MAKE) $(JOBS_ARG); \
		$(MAKE) install
	
	# hook into upstream toolchain
	rm -rf toolchain/inst
	ln -fs ../debian/toolchain/inst toolchain/
	
	# compile the firmware using the newly built cross toolchain
	dh_auto_build
	cp carlfw/carl9170.fw $$(sed -n 's/^CONFIG_CARL9170FW_RELEASE_VERSION=\(.*\)/carlfw\/carl9170-\1.fw/p' .config)

override_dh_install:
	dh_install $$(sed -n 's/^CONFIG_CARL9170FW_RELEASE_VERSION=\(.*\)/carlfw\/carl9170-\1.fw/p' .config) lib/firmware/

override_dh_clean:
	rm -rf	debian/toolchain \
		toolchain/inst \
		carlfw/carl9170*.fw \
		include/generated \
		.config* \
		CMakeCache.txt \
		CMakeFiles \
		Makefile \
		carlfw/CMakeFiles \
		carlfw/Makefile \
		carlfw/cmake_install.cmake \
		cmake_install.cmake \
		config.cmake \
		config/CMakeCache.txt \
		config/CMakeFiles \
		config/Makefile \
		config/cmake_install.cmake \
		config/zconf.tab.h
	dh_clean
